/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TARMSANCIONDECOMISO")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tarmsanciondecomiso.findAll", query = "SELECT t FROM Tarmsanciondecomiso t"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByCdecomiso", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.tarmsanciondecomisoPK.cdecomiso = :cdecomiso"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByCsanciondecomiso", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.tarmsanciondecomisoPK.csanciondecomiso = :csanciondecomiso"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByCdocumento", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.cdocumento = :cdocumento"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByFechainicio", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.fechainicio = :fechainicio"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByFechafinal", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.fechafinal = :fechafinal"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByXpath", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.xpath = :xpath"),
    @NamedQuery(name = "Tarmsanciondecomiso.findByNoresolucion", query = "SELECT t FROM Tarmsanciondecomiso t WHERE t.noresolucion = :noresolucion")})
public class Tarmsanciondecomiso implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TarmsanciondecomisoPK tarmsanciondecomisoPK;
    @Column(name = "CDOCUMENTO")
    private Long cdocumento;
    @Column(name = "FECHAINICIO")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fechainicio;
    @Column(name = "FECHAFINAL")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fechafinal;
    @Column(name = "XPATH")
    private String xpath;
    @Column(name = "NORESOLUCION")
    private String noresolucion;
    @JoinColumn(name = "CARMA", referencedColumnName = "CARMA")
    @ManyToOne
    private Tarmarmas carma;
    @JoinColumn(name = "CDECOMISO", referencedColumnName = "CDECOMISO", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tarmdecomiso tarmdecomiso;
    @JoinColumn(name = "CTIPOSANCION", referencedColumnName = "CTIPOSANCION")
    @ManyToOne
    private Tarmtiposancion ctiposancion;
    @JoinColumn(name = "PERSONCODE", referencedColumnName = "PERSONCODE")
    @ManyToOne
    private Tcustperson personcode;
    @OneToMany(mappedBy = "tarmsanciondecomiso")
    private Collection<Tarmsancionrecomendacion> tarmsancionrecomendacionCollection;

    public Tarmsanciondecomiso() {
    }

    public Tarmsanciondecomiso(TarmsanciondecomisoPK tarmsanciondecomisoPK) {
        this.tarmsanciondecomisoPK = tarmsanciondecomisoPK;
    }

    public Tarmsanciondecomiso(long cdecomiso, String csanciondecomiso) {
        this.tarmsanciondecomisoPK = new TarmsanciondecomisoPK(cdecomiso, csanciondecomiso);
    }

    public TarmsanciondecomisoPK getTarmsanciondecomisoPK() {
        return tarmsanciondecomisoPK;
    }

    public void setTarmsanciondecomisoPK(TarmsanciondecomisoPK tarmsanciondecomisoPK) {
        this.tarmsanciondecomisoPK = tarmsanciondecomisoPK;
    }

    public Long getCdocumento() {
        return cdocumento;
    }

    public void setCdocumento(Long cdocumento) {
        this.cdocumento = cdocumento;
    }

    public Date getFechainicio() {
        return fechainicio;
    }

    public void setFechainicio(Date fechainicio) {
        this.fechainicio = fechainicio;
    }

    public Date getFechafinal() {
        return fechafinal;
    }

    public void setFechafinal(Date fechafinal) {
        this.fechafinal = fechafinal;
    }

    public String getXpath() {
        return xpath;
    }

    public void setXpath(String xpath) {
        this.xpath = xpath;
    }

    public String getNoresolucion() {
        return noresolucion;
    }

    public void setNoresolucion(String noresolucion) {
        this.noresolucion = noresolucion;
    }

    public Tarmarmas getCarma() {
        return carma;
    }

    public void setCarma(Tarmarmas carma) {
        this.carma = carma;
    }

    public Tarmdecomiso getTarmdecomiso() {
        return tarmdecomiso;
    }

    public void setTarmdecomiso(Tarmdecomiso tarmdecomiso) {
        this.tarmdecomiso = tarmdecomiso;
    }

    public Tarmtiposancion getCtiposancion() {
        return ctiposancion;
    }

    public void setCtiposancion(Tarmtiposancion ctiposancion) {
        this.ctiposancion = ctiposancion;
    }

    public Tcustperson getPersoncode() {
        return personcode;
    }

    public void setPersoncode(Tcustperson personcode) {
        this.personcode = personcode;
    }

    @XmlTransient
    public Collection<Tarmsancionrecomendacion> getTarmsancionrecomendacionCollection() {
        return tarmsancionrecomendacionCollection;
    }

    public void setTarmsancionrecomendacionCollection(Collection<Tarmsancionrecomendacion> tarmsancionrecomendacionCollection) {
        this.tarmsancionrecomendacionCollection = tarmsancionrecomendacionCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tarmsanciondecomisoPK != null ? tarmsanciondecomisoPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tarmsanciondecomiso)) {
            return false;
        }
        Tarmsanciondecomiso other = (Tarmsanciondecomiso) object;
        if ((this.tarmsanciondecomisoPK == null && other.tarmsanciondecomisoPK != null) || (this.tarmsanciondecomisoPK != null && !this.tarmsanciondecomisoPK.equals(other.tarmsanciondecomisoPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tarmsanciondecomiso[ tarmsanciondecomisoPK=" + tarmsanciondecomisoPK + " ]";
    }
    
}
